Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 446)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Environment.cpp	(revision 448)
@@ -1269,5 +1269,5 @@
 	  "100000");
 
-  RegisterOption("BspTree.Construction.sideTolerance",
+  RegisterOption("BspTree.Construction.epsilon",
 	  optFloat,
 	  "-bsp_construction_side_tolerance=",
@@ -1732,7 +1732,17 @@
 	  "false");
 
-   RegisterOption("VspBspTree.Factor.leastRaySplits", optFloat, "-vsp_bsp_factor_least_ray_splits=", "1.0");
-   RegisterOption("VspBspTree.Factor.balancedRays", optFloat, "-vsp_bsp_factor_balanced_rays=", "1.0");
-   RegisterOption("VspBspTree.Factor.pvs", optFloat, "-vsp_bsp_factor_pvs=", "1.0");
+  RegisterOption("VspBspTree.Construction.samples",
+	  optInt,
+	  "-bsp_construction_samples=",
+	  "100000");
+
+  RegisterOption("VspBspTree.Construction.epsilon",
+	  optFloat,
+	  "-vsp_bsp_construction_side_tolerance=",
+	  "0.002");
+
+  RegisterOption("VspBspTree.Factor.leastRaySplits", optFloat, "-vsp_bsp_factor_least_ray_splits=", "1.0");
+  RegisterOption("VspBspTree.Factor.balancedRays", optFloat, "-vsp_bsp_factor_balanced_rays=", "1.0");
+  RegisterOption("VspBspTree.Factor.pvs", optFloat, "-vsp_bsp_factor_pvs=", "1.0");
 
    //////////////////////////////////////////////////////////////////////////////////
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Exporter.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Exporter.h	(revision 446)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Exporter.h	(revision 448)
@@ -20,4 +20,5 @@
 class Polygon3;
 class VssTree;
+class VspBspTree;
 class RssTree;
 
@@ -44,5 +45,4 @@
   virtual bool ExportScene(SceneGraphNode *node) = 0;
 
-
   virtual bool
   ExportBox(const AxisAlignedBox3 &box) = 0;
@@ -56,9 +56,4 @@
   virtual bool
   ExportVssTree2(const VssTree &tree,
-				 const Vector3 direction
-				 ) = 0;
-
-  virtual bool
-  ExportRssTree2(const RssTree &tree,
 				 const Vector3 direction
 				 ) = 0;
@@ -98,7 +93,14 @@
   virtual void 
   ExportBspSplits(const BspTree &tree, const bool exportDepth = false) = 0;
+
   virtual void
   ExportLeavesGeometry(const BspTree &tree, const vector<BspLeaf *> &leaves) = 0;
-	
+  
+  virtual void 
+  ExportBspSplits(const VspBspTree &tree, const bool exportDepth = false) = 0;
+
+  virtual void
+  ExportBspViewCellPartition(const VspBspTree &tree, const int maxPvs = 0) = 0;
+
   virtual void 
   ExportPolygons(const PolygonContainer &polys) = 0;
@@ -112,4 +114,8 @@
   virtual void
   ExportGeometry(const ObjectContainer &objects) = 0;
+
+  virtual bool
+  ExportRssTree2(const RssTree &tree,
+				 const Vector3 direction) = 0;
 
   void SetExportRayDensity(const bool d) { mExportRayDensity = d; }
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp	(revision 440)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/RenderSimulator.cpp	(revision 448)
@@ -3,4 +3,6 @@
 #include "ViewCellBsp.h"
 #include "ViewCell.h"
+#include "VspBspTree.h"
+
 
 void SimulationStatistics::Print(ostream &app) const
@@ -53,4 +55,6 @@
 /*     class BspRenderSimulator implementation          */
 /********************************************************/
+
+
 BspRenderSimulator::BspRenderSimulator(BspTree *bspTree):
 mBspTree(bspTree)
@@ -139,5 +143,5 @@
 
 Real BspRenderSimulator::RenderPvs(ViewCell &viewCell, 
-									   float objRenderTime) const
+								   float objRenderTime) const
 {
 	return viewCell.GetPvs().GetSize() * objRenderTime;
@@ -234,2 +238,98 @@
 	return leaf->mKdPvs.GetSize() * objRenderTime;
 }
+
+/********************************************************/
+/*     class BspRenderSimulator implementation          */
+/********************************************************/
+VspBspRenderSimulator::VspBspRenderSimulator(VspBspTree *vspBspTree):
+mVspBspTree(vspBspTree)
+{
+}
+
+VspBspRenderSimulator::VspBspRenderSimulator(float objRenderCost, 
+											 float vcOverhead, 
+											 float moveSpeed,
+											 VspBspTree *vspBspTree):
+RenderSimulator(objRenderCost, vcOverhead, moveSpeed), 
+mVspBspTree(vspBspTree)
+{
+}
+
+SimulationStatistics VspBspRenderSimulator::SimulateRendering()
+{
+	SimulationStatistics simStat;
+
+	simStat.Reset();
+	simStat.Start();
+
+	Real renderTime = 0;
+	
+	// overhead for loading the PVS of the view cells
+	float loadPvsOverhead = 0;
+	// probability that view point lies in a view cell
+	float pInVcTotal = 0;
+
+	// total probability that a view cell border is crossed
+	const float pCrossVcTotal = mVspBspTree->GetBoundingBox().SurfaceArea();
+
+	// collect all view cells
+	ViewCellContainer viewCells;
+	mVspBspTree->CollectViewCells(viewCells);
+
+	ViewCellContainer::const_iterator it, it_end = viewCells.end();
+
+	// surface area substitute for probability
+	PolygonContainer geom;
+float overallarea = 0;
+	for (it = viewCells.begin(); it != it_end; ++ it)
+	{
+		// compute view cell area
+		mVspBspTree->ConstructGeometry(dynamic_cast<BspViewCell *>(*it), geom);
+
+		const float area = Polygon3::GetArea(geom);
+		if (area < 0.0001)
+			Debug << "warning, area: " << area << endl;
+		CLEAR_CONTAINER(geom);
+
+		// area substitute for view point probability
+		float pInVc = area;
+				
+		// compute render time of PVS times probability that view point is in view cell
+		float vcCost = pInVc * RenderPvs(*(*it), mObjRenderCost);
+		//Debug << "p: " << pInVc << " rendercost: " << RenderPvs(*(*it), mObjRenderCost) << endl;
+		renderTime += vcCost;
+
+		if (vcCost > simStat.maxCost)
+			simStat.maxCost = vcCost;
+		else if (vcCost < simStat.minCost)
+			simStat.minCost = vcCost;
+
+		// probability that a view cell border is crossed
+		float pCrossVc = area * mMoveSpeed;
+
+		// crossing the border of a view cell is also depending on the move speed
+		loadPvsOverhead += pCrossVc * mVcOverhead;
+overallarea += area;
+		pInVcTotal += pInVc;
+	}
+	Debug << "overall area: " << overallarea << endl;
+	
+	renderTime /= pInVcTotal;
+	loadPvsOverhead /= pCrossVcTotal;
+
+	simStat.avgRtWithoutOverhead = renderTime;
+	simStat.avgRenderTime = renderTime + loadPvsOverhead;
+	
+	simStat.maxCost /= pInVcTotal;
+	simStat.minCost /= pInVcTotal;
+
+	simStat.Stop();
+
+	return simStat;
+}
+
+Real VspBspRenderSimulator::RenderPvs(ViewCell &viewCell, 
+									  float objRenderTime) const
+{
+	return viewCell.GetPvs().GetSize() * objRenderTime;
+}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 445)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/ViewCellBsp.cpp	(revision 448)
@@ -98,7 +98,7 @@
 }
 
-Plane3 *BspInterior::GetPlane()
-{
-	return &mPlane;
+Plane3 BspInterior::GetPlane() const
+{
+	return mPlane;
 }
 
@@ -117,81 +117,13 @@
 }
 
-int BspInterior::SplitPolygons(PolygonContainer &polys, 
-							   PolygonContainer &frontPolys, 
-							   PolygonContainer &backPolys, 
-							   PolygonContainer &coincident)
-{
-	int splits = 0;
-
-#ifdef _Debug
-	Debug << "splitting polygons of node " << this << " with plane " << mPlane << endl;
-#endif
-	while (!polys.empty())
-	{
-		Polygon3 *poly = polys.back();
-		polys.pop_back();
-
-		//Debug << "New polygon with plane: " << poly->GetSupportingPlane() << "\n";
-
-		// classify polygon
-		const int cf = poly->ClassifyPlane(mPlane);
-
-		switch (cf)
-		{
-			case Polygon3::COINCIDENT:
-				coincident.push_back(poly);
-				break;			
-			case Polygon3::FRONT_SIDE:	
-				frontPolys.push_back(poly);
-				break;
-			case Polygon3::BACK_SIDE:
-				backPolys.push_back(poly);
-				break;
-			case Polygon3::SPLIT:
-				{
-					Polygon3 *front_piece = new Polygon3(poly->mParent);
-					Polygon3 *back_piece = new Polygon3(poly->mParent);
-
-					//-- split polygon into front and back part
-					poly->Split(mPlane, *front_piece, *back_piece);
-					
-					++ splits; // increase number of splits
-
-					//-- inherit rays from parent polygon for blocked ray criterium
-					poly->InheritRays(*front_piece, *back_piece);
-					//Debug << "p: " << poly->mPiercingRays.size() << " f: " << front_piece->mPiercingRays.size() << " b: " << back_piece->mPiercingRays.size() << endl;
-				
-					// check if polygons still valid 
-					if (front_piece->Valid())
-						frontPolys.push_back(front_piece);
-					else
-						DEL_PTR(front_piece);
-				
-					if (back_piece->Valid())
-						backPolys.push_back(back_piece);
-					else				
-						DEL_PTR(back_piece);
-				
-#ifdef _DEBUG
-					Debug << "split " << *poly << endl << *front_piece << endl << *back_piece << endl;
-#endif
-					DEL_PTR(poly);
-				}
-				break;
-			default:
-                Debug << "SHOULD NEVER COME HERE\n";
-				break;
-		}
-	}
-
-	return splits;
-}
-
 /****************************************************************/
 /*                  class BspLeaf implementation                */
 /****************************************************************/
+
+
 BspLeaf::BspLeaf(): mViewCell(NULL)
 {
 }
+
 
 BspLeaf::BspLeaf(BspViewCell *viewCell): 
@@ -199,4 +131,5 @@
 {
 }
+
 
 BspLeaf::BspLeaf(BspInterior *parent): 
@@ -204,4 +137,6 @@
 {}
 
+
+
 BspLeaf::BspLeaf(BspInterior *parent, BspViewCell *viewCell): 
 BspNode(parent), mViewCell(viewCell)
@@ -222,36 +157,4 @@
 { 
 	return true; 
-}
-
-void BspLeaf::AddToPvs(const BoundedRayContainer &rays, 
-					   int &sampleContributions,
-					   int &contributingSamples)
-{
-	sampleContributions = 0;
-	contributingSamples = 0;
-
-    BoundedRayContainer::const_iterator it, it_end = rays.end();
-
-	// add contributions from samples to the PVS
-	for (it = rays.begin(); it != it_end; ++ it)
-	{
-		int contribution = 0;
-		Ray *ray = (*it)->mRay;
-			
-		if (!ray->intersections.empty())
-			contribution += mViewCell->GetPvs().AddSample(ray->intersections[0].mObject);
-		
-		if (ray->sourceObject.mObject)
-			contribution += mViewCell->GetPvs().AddSample(ray->sourceObject.mObject);
-
-		if (contribution)
-		{
-			sampleContributions += contribution;
-			++ contributingSamples;
-		}
-
-		//if (ray->mFlags & Ray::STORE_BSP_INTERSECTIONS)
-			ray->bspIntersections.push_back(Ray::BspIntersection((*it)->mMinT, this));
-	}
 }
 
@@ -308,8 +211,6 @@
 	environment->GetIntValue("BspTree.maxTests", mMaxTests);
 
-	environment->GetFloatValue("BspTree.Construction.sideTolerance", Vector3::sDistTolerance);
-	Vector3::sDistToleranceSqrt = Vector3::sDistTolerance * Vector3::sDistTolerance;
-
-
+	environment->GetFloatValue("BspTree.Construction.epsilon", mEpsilon);
+	
     Debug << "BSP max depth: " << mTermMaxDepth << endl;
 	Debug << "BSP min PVS: " << mTermMinPvs << endl;
@@ -347,8 +248,85 @@
 }
 
+
 const BspTreeStatistics &BspTree::GetStatistics() const 
 {
 	return mStat;
 }
+
+
+int BspTree::SplitPolygons(const Plane3 &plane,
+						   PolygonContainer &polys, 
+						   PolygonContainer &frontPolys, 
+						   PolygonContainer &backPolys, 
+						   PolygonContainer &coincident) const
+{
+	int splits = 0;
+
+#ifdef _Debug
+	Debug << "splitting polygons of node " << this << " with plane " << mPlane << endl;
+#endif
+	while (!polys.empty())
+	{
+		Polygon3 *poly = polys.back();
+		polys.pop_back();
+
+		//Debug << "New polygon with plane: " << poly->GetSupportingPlane() << "\n";
+
+		// classify polygon
+		const int cf = poly->ClassifyPlane(plane, mEpsilon);
+
+		switch (cf)
+		{
+			case Polygon3::COINCIDENT:
+				coincident.push_back(poly);
+				break;			
+			case Polygon3::FRONT_SIDE:	
+				frontPolys.push_back(poly);
+				break;
+			case Polygon3::BACK_SIDE:
+				backPolys.push_back(poly);
+				break;
+			case Polygon3::SPLIT:
+				{
+					Polygon3 *front_piece = new Polygon3(poly->mParent);
+					Polygon3 *back_piece = new Polygon3(poly->mParent);
+
+					//-- split polygon into front and back part
+					poly->Split(plane, 
+								*front_piece, 
+								*back_piece,
+								mEpsilon);
+					
+					++ splits; // increase number of splits
+
+					//-- inherit rays from parent polygon for blocked ray criterium
+					poly->InheritRays(*front_piece, *back_piece);
+				
+					// check if polygons still valid 
+					if (front_piece->Valid(mEpsilon))
+						frontPolys.push_back(front_piece);
+					else
+						DEL_PTR(front_piece);
+				
+					if (back_piece->Valid(mEpsilon))
+						backPolys.push_back(back_piece);
+					else				
+						DEL_PTR(back_piece);
+				
+#ifdef _DEBUG
+					Debug << "split " << *poly << endl << *front_piece << endl << *back_piece << endl;
+#endif
+					DEL_PTR(poly);
+				}
+				break;
+			default:
+                Debug << "SHOULD NEVER COME HERE\n";
+				break;
+		}
+	}
+
+	return splits;
+}
+
 
 void BspTreeStatistics::Print(ostream &app) const
@@ -458,8 +436,9 @@
 		
 				// split viewcell polygons with respect to split plane
-				splits += interior->SplitPolygons(*tData.mPolygons,
-												  *frontPolys, 
-												  *backPolys,
-												  coincident);
+				splits += SplitPolygons(interior->GetPlane(),
+										*tData.mPolygons, 
+										*frontPolys, 
+										*backPolys, 
+										coincident);
 				
 				// extract view cells associated with the split polygons
@@ -505,4 +484,5 @@
 			// cleanup
 			DEL_PTR(tData.mPolygons);
+			DEL_PTR(tData.mRays);
 		}
 		else
@@ -514,5 +494,7 @@
 }
 
-int BspTree::AddMeshToPolygons(Mesh *mesh, PolygonContainer &polys, MeshInstance *parent)
+int BspTree::AddMeshToPolygons(Mesh *mesh, 
+							   PolygonContainer &polys, 
+							   MeshInstance *parent)
 {
 	FaceContainer::const_iterator fi;
@@ -523,5 +505,5 @@
 		Polygon3 *poly = new Polygon3((*fi), mesh);
 		
-		if (poly->Valid())
+		if (poly->Valid(mEpsilon))
 		{
 			poly->mParent = parent; // set parent intersectable
@@ -684,5 +666,5 @@
 
 		float minT, maxT;
-		if (BoundRay(*ray, minT, maxT))
+		if (mBox.GetRaySegment(*ray, minT, maxT))
 			rays->push_back(new BoundedRay(ray, minT, maxT));
 	}
@@ -719,5 +701,5 @@
 
 		float minT, maxT;
-		if (BoundRay(*ray, minT, maxT))
+		if (mBox.GetRaySegment(*ray, minT, maxT))
 			rays->push_back(new BoundedRay(ray, minT, maxT));
 	}
@@ -801,5 +783,5 @@
 		{
 			int conSamp = 0, sampCon = 0;
-			leaf->AddToPvs(*tData.mRays, conSamp, sampCon);
+			AddToPvs(leaf, *tData.mRays, conSamp, sampCon);
 			
 			mStat.contributingSamples += conSamp;
@@ -818,5 +800,6 @@
 		DEL_PTR(tData.mPolygons);
 		DEL_PTR(tData.mRays);
-			
+		DEL_PTR(tData.mGeometry);
+
 		return leaf;
 	}
@@ -860,4 +843,5 @@
 	// cleanup
 	DEL_PTR(tData.mNode);
+
 	DEL_PTR(tData.mPolygons);
 	DEL_PTR(tData.mRays);
@@ -916,6 +900,6 @@
 	
 
-	Debug << "number of rays: " << tData.mRays->size() << endl;
-	Debug << "number of polys: " << tData.mPolygons->size() << endl;
+	Debug << "number of rays: " << (int)tData.mRays->size() << endl;
+	Debug << "number of polys: " << (int)tData.mPolygons->size() << endl;
 
 	startTime = GetTime();
@@ -928,8 +912,9 @@
 	startTime = GetTime();
 	// subdivide polygons with plane
-	mStat.splits += interior->SplitPolygons(*tData.mPolygons, 
-		                                    *frontData.mPolygons, 
-											*backData.mPolygons, 
-											coincident);
+	mStat.splits += SplitPolygons(interior->GetPlane(),
+								  *tData.mPolygons, 
+		                          *frontData.mPolygons, 
+								  *backData.mPolygons, 
+								  coincident);
 
 	Debug << "time used for polygon splitting: " << TimeDiff(startTime, GetTime())*1e-3 << "s" << endl;
@@ -944,6 +929,7 @@
 		tData.mGeometry->SplitGeometry(*frontData.mGeometry, 
 									   *backData.mGeometry, 
-									   *this, 
-									   interior->mPlane);
+									   interior->mPlane,
+									   mBox,
+									   mEpsilon);
 	
 		
@@ -974,6 +960,6 @@
 	interior->SetupChildLinks(new BspLeaf(interior), new BspLeaf(interior));
 	
-	frontData.mNode = interior->mFront;
-	backData.mNode = interior->mBack;
+	frontData.mNode = interior->GetFront();
+	backData.mNode = interior->GetBack();
 	
 	//DEL_PTR(leaf);
@@ -1269,5 +1255,6 @@
 
 			BoundedRay *bRay = (*rays)[idx[j]];
-			pt[j] = chooseMin ? bRay->mRay->Extrap(bRay->mMinT) : bRay->mRay->Extrap(bRay->mMaxT);
+			pt[j] = chooseMin ? bRay->mRay->Extrap(bRay->mMinT) : 
+								bRay->mRay->Extrap(bRay->mMaxT);
 		}	
 			
@@ -1347,5 +1334,6 @@
 		Polygon3 *poly = polys[testIdx];
 
-        const int classification = poly->ClassifyPlane(candidatePlane);
+        const int classification = 
+			poly->ClassifyPlane(candidatePlane, mEpsilon);
 
 		if (mSplitPlaneStrategy & BALANCED_POLYS)
@@ -1437,26 +1425,4 @@
 }
 
-bool BspTree::BoundRay(const Ray &ray, float &minT, float &maxT) const
-{
-	maxT = 1e6;
-	minT = 0;
-	
-	// test with tree bounding box
-	if (!mBox.GetMinMaxT(ray, &minT, &maxT))
-		return false;
-
-	if (minT < 0) // start ray from origin
-		minT = 0;
-
-	// bound ray or line segment
-	if (//(ray.GetType() == Ray::LOCAL_RAY) && 
-	    !ray.intersections.empty() && 
-		(ray.intersections[0].mT <= maxT))
-	{
-		maxT = ray.intersections[0].mT;
-	}
-
-	return true;
-}
 
 inline void BspTree::GenerateUniqueIdsForPvs()
@@ -1499,5 +1465,9 @@
 			BspNodeGeometry backCell;
 
-			cell.SplitGeometry(frontCell, backCell, *this, candidatePlane);
+			cell.SplitGeometry(frontCell, 
+							   backCell, 
+							   candidatePlane,
+							   mBox,
+							   mEpsilon);
 		
 			pFront = frontCell.GetArea();
@@ -1803,5 +1773,5 @@
 	float maxt, mint;
 
-	if (!BoundRay(ray, mint, maxt))
+	if (!mBox.GetRaySegment(ray, mint, maxt))
 		return 0;
 
@@ -1818,12 +1788,9 @@
 		if (!node->IsLeaf()) 
 		{
-			BspInterior *in = (BspInterior *) node;
+			BspInterior *in = dynamic_cast<BspInterior *>(node);
 			
-			Plane3 *splitPlane = in->GetPlane();
-
-			int entSide = splitPlane->Side(entp);
-			int extSide = splitPlane->Side(extp);
-
-			Vector3 intersection;
+			Plane3 splitPlane = in->GetPlane();
+			const int entSide = splitPlane.Side(entp);
+			const int extSide = splitPlane.Side(extp);
 
 			if (entSide < 0)
@@ -1858,5 +1825,5 @@
 			// find intersection of ray segment with plane
 			float t;
-			extp = splitPlane->FindIntersection(ray.GetLoc(), extp, &t);
+			extp = splitPlane.FindIntersection(ray.GetLoc(), extp, &t);
 			maxt *= t;
 			
@@ -1934,6 +1901,6 @@
 			BspInterior *interior = dynamic_cast<BspInterior *>(node);
 
-			nodeStack.push(interior->mFront);
-			nodeStack.push(interior->mBack);
+			nodeStack.push(interior->GetFront());
+			nodeStack.push(interior->GetBack());
 		}
 	}
@@ -1989,6 +1956,6 @@
 			BspInterior *interior = dynamic_cast<BspInterior *>(node);
 
-			nodeStack.push(interior->mFront);
-			nodeStack.push(interior->mBack);
+			nodeStack.push(interior->GetFront());
+			nodeStack.push(interior->GetBack());
 		}
 	}
@@ -2101,7 +2068,7 @@
 		{
 			BspInterior *interior = dynamic_cast<BspInterior *>(n);
-			Plane3 halfSpace = *dynamic_cast<BspInterior *>(interior)->GetPlane();
-
-            if (interior->mFront != lastNode)
+			Plane3 halfSpace = dynamic_cast<BspInterior *>(interior)->GetPlane();
+
+            if (interior->GetFront() != lastNode)
 				halfSpace.ReverseOrientation();
 
@@ -2135,5 +2102,5 @@
 	ExtractHalfSpaces(n, halfSpaces);
 
-	PolygonContainer candidatePolys;
+	PolygonContainer candidates;
 
 	// bounded planes are added to the polygons (reverse polygons
@@ -2143,7 +2110,7 @@
 		Polygon3 *p = GetBoundingBox().CrossSection(halfSpaces[i]);
 		
-		if (p->Valid())
-		{
-			candidatePolys.push_back(p->CreateReversePolygon());
+		if (p->Valid(mEpsilon))
+		{
+			candidates.push_back(p->CreateReversePolygon());
 			DEL_PTR(p);
 		}
@@ -2158,11 +2125,11 @@
 			vertices.push_back(mBox.GetFace(i).mVertices[j]);
 
-		candidatePolys.push_back(new Polygon3(vertices));
-	}
-
-	for (int i = 0; i < (int)candidatePolys.size(); ++ i)
+		candidates.push_back(new Polygon3(vertices));
+	}
+
+	for (int i = 0; i < (int)candidates.size(); ++ i)
 	{
 		// polygon is split by all other planes
-		for (int j = 0; (j < (int)halfSpaces.size()) && candidatePolys[i]; ++ j)
+		for (int j = 0; (j < (int)halfSpaces.size()) && candidates[i]; ++ j)
 		{
 			if (i == j) // polygon and plane are coincident
@@ -2172,5 +2139,6 @@
 			Polygon3 *frontPoly, *backPoly;
 
-			const int cf = candidatePolys[i]->ClassifyPlane(halfSpaces[j]);
+			const int cf = candidates[i]->
+				ClassifyPlane(halfSpaces[j], mEpsilon);
 			
 			switch (cf)
@@ -2180,12 +2148,13 @@
 					backPoly = new Polygon3();
 
-					candidatePolys[i]->Split(halfSpaces[j], 
-											 *frontPoly, 
-											 *backPoly);
-
-					DEL_PTR(candidatePolys[i]);
-
-					if (frontPoly->Valid())
-						candidatePolys[i] = frontPoly;
+					candidates[i]->Split(halfSpaces[j], 
+										 *frontPoly, 
+										 *backPoly,
+										 mEpsilon);
+
+					DEL_PTR(candidates[i]);
+
+					if (frontPoly->Valid(mEpsilon))
+						candidates[i] = frontPoly;
 					else
 						DEL_PTR(frontPoly);
@@ -2194,5 +2163,5 @@
 					break;
 				case Polygon3::BACK_SIDE:
-					DEL_PTR(candidatePolys[i]);
+					DEL_PTR(candidates[i]);
 					break;
 				// just take polygon as it is
@@ -2204,6 +2173,6 @@
 		}
 		
-		if (candidatePolys[i])
-			cell.push_back(candidatePolys[i]);
+		if (candidates[i])
+			cell.push_back(candidates[i]);
 	}
 }
@@ -2242,5 +2211,7 @@
 				{
 					const int cf = 
-						Polygon3::ClassifyPlane(neighborCandidate, halfSpaces[i]);
+						Polygon3::ClassifyPlane(neighborCandidate, 
+												halfSpaces[i],
+												mEpsilon);
 
 					if (cf == Polygon3::BACK_SIDE)
@@ -2258,16 +2229,18 @@
 			BspInterior *interior = dynamic_cast<BspInterior *>(node);
 	
-			const int cf = Polygon3::ClassifyPlane(cell, interior->mPlane);
+			const int cf = Polygon3::ClassifyPlane(cell, 
+												   interior->mPlane,
+												   mEpsilon);
 
 			if (cf == Polygon3::FRONT_SIDE)
-				nodeStack.push(interior->mFront);
+				nodeStack.push(interior->GetFront());
 			else
 				if (cf == Polygon3::BACK_SIDE)
-					nodeStack.push(interior->mBack);
+					nodeStack.push(interior->GetBack());
 				else 
 				{
 					// random decision
-					nodeStack.push(interior->mBack);
-					nodeStack.push(interior->mFront);
+					nodeStack.push(interior->GetBack());
+					nodeStack.push(interior->GetFront());
 				}
 		}
@@ -2305,18 +2278,20 @@
 			ConstructGeometry(interior, cell);
 
-			const int cf = Polygon3::ClassifyPlane(cell, halfspace);
+			const int cf = Polygon3::ClassifyPlane(cell, 
+												   halfspace, 
+												   mEpsilon);
 
 			if (cf == Polygon3::BACK_SIDE)
-				next = interior->mFront;
+				next = interior->GetFront();
 			else
 				if (cf == Polygon3::FRONT_SIDE)
-					next = interior->mFront;
+					next = interior->GetFront();
 			else 
 			{
 				// random decision
 				if (mask & 1)
-					next = interior->mBack;
+					next = interior->GetBack();
 				else
-					next = interior->mFront;
+					next = interior->GetFront();
 				mask = mask >> 1;
 			}
@@ -2353,7 +2328,7 @@
 			// random decision
 			if (mask & 1)
-				nodeStack.push(interior->mBack);
+				nodeStack.push(interior->GetBack());
 			else
-				nodeStack.push(interior->mFront);
+				nodeStack.push(interior->GetFront());
 
 			mask = mask >> 1;
@@ -2362,4 +2337,39 @@
 	
 	return NULL;
+}
+
+void BspTree::AddToPvs(BspLeaf *leaf,
+					   const BoundedRayContainer &rays, 
+					   int &sampleContributions,
+					   int &contributingSamples)
+{
+	sampleContributions = 0;
+	contributingSamples = 0;
+
+    BoundedRayContainer::const_iterator it, it_end = rays.end();
+
+	ViewCell *vc = leaf->GetViewCell();
+
+	// add contributions from samples to the PVS
+	for (it = rays.begin(); it != it_end; ++ it)
+	{
+		int contribution = 0;
+		Ray *ray = (*it)->mRay;
+			
+		if (!ray->intersections.empty())
+			contribution += vc->GetPvs().AddSample(ray->intersections[0].mObject);
+		
+		if (ray->sourceObject.mObject)
+			contribution += vc->GetPvs().AddSample(ray->sourceObject.mObject);
+
+		if (contribution)
+		{
+			sampleContributions += contribution;
+			++ contributingSamples;
+		}
+
+		//if (ray->mFlags & Ray::STORE_BSP_INTERSECTIONS)
+		//	ray->bspIntersections.push_back(Ray::BspIntersection((*it)->mMinT, this));
+	}
 }
 
@@ -2397,7 +2407,39 @@
 }
 
-/*************************************************************
- *            BspNodeGeometry Implementation                 *
- *************************************************************/
+float BspTree::GetEpsilon() const
+{
+	return mEpsilon;
+}
+
+void BspViewCellsStatistics::Print(ostream &app) const
+{
+	app << "===== BspViewCells statistics ===============\n";
+
+	app << setprecision(4);
+
+	//app << "#N_CTIME  ( Construction time [s] )\n" << Time() << " \n";
+
+	app << "#N_OVERALLPVS ( objects in PVS )\n" << pvs << endl;
+
+	app << "#N_PMAXPVS ( largest PVS )\n" << maxPvs << endl;
+
+	app << "#N_PMINPVS ( smallest PVS )\n" << minPvs << endl;
+
+	app << "#N_PAVGPVS ( average PVS )\n" << AvgPvs() << endl;
+
+	app << "#N_PEMPTYPVS ( view cells with PVS smaller 2 )\n" << emptyPvs << endl;
+
+	app << "#N_VIEWCELLS ( number of view cells)\n" << viewCells << endl;
+
+	app << "#N_AVGBSPLEAVES (average number of BSP leaves per view cell )\n" << AvgBspLeaves() << endl;
+
+	app << "#N_MAXBSPLEAVES ( maximal number of BSP leaves per view cell )\n" << maxBspLeaves << endl;
+	
+	app << "===== END OF BspViewCells statistics ==========\n";
+}
+
+/*************************************************************/
+/*            BspNodeGeometry Implementation                 */
+/*************************************************************/
 
 BspNodeGeometry::~BspNodeGeometry()
@@ -2413,18 +2455,21 @@
 void BspNodeGeometry::SplitGeometry(BspNodeGeometry &front,
 									BspNodeGeometry &back,
-									const BspTree &tree,						 
-									const Plane3 &splitPlane) const
+									const Plane3 &splitPlane,
+									const AxisAlignedBox3 &box,
+									const float epsilon) const
 {	
 	// get cross section of new polygon
-	Polygon3 *planePoly = tree.GetBoundingBox().CrossSection(splitPlane);
-
-	planePoly = SplitPolygon(planePoly, tree);
-
-	//-- plane poly splits all other cell polygons
+	Polygon3 *planePoly = box.CrossSection(splitPlane);
+
+	// split polygon with all other polygons
+	planePoly = SplitPolygon(planePoly, epsilon);
+
+	//-- new polygon splits all other polygons
 	for (int i = 0; i < (int)mPolys.size(); ++ i)
 	{
-		const int cf = mPolys[i]->ClassifyPlane(splitPlane, 0.00001f);
+		/// don't use epsilon here to get exact split planes
+		const int cf = 
+			mPolys[i]->ClassifyPlane(splitPlane, Limits::Small);
 			
-		// split new polygon with all previous planes
 		switch (cf)
 		{
@@ -2436,14 +2481,17 @@
 					Polygon3 *backPoly = new Polygon3();
 				
-					poly->Split(splitPlane, *frontPoly, *backPoly);
+					poly->Split(splitPlane, 
+								*frontPoly, 
+								*backPoly,
+								epsilon);
 
 					DEL_PTR(poly);
 
-					if (frontPoly->Valid())
+					if (frontPoly->Valid(epsilon))
 						front.mPolys.push_back(frontPoly);
 					else
 						DEL_PTR(frontPoly);
 
-					if (backPoly->Valid())
+					if (backPoly->Valid(epsilon))
 						back.mPolys.push_back(backPoly);
 					else
@@ -2467,5 +2515,5 @@
 	}
 
-	//-- finally add the new polygon to the child cells
+	//-- finally add the new polygon to the child node geometries
 	if (planePoly)
 	{
@@ -2481,6 +2529,9 @@
 
 Polygon3 *BspNodeGeometry::SplitPolygon(Polygon3 *planePoly,
-										const BspTree &tree) const
-{
+										const float epsilon) const
+{
+	if (!planePoly->Valid(epsilon))
+		DEL_PTR(planePoly);
+
 	// polygon is split by all other planes
 	for (int i = 0; (i < (int)mPolys.size()) && planePoly; ++ i)
@@ -2488,6 +2539,7 @@
 		Plane3 plane = mPolys[i]->GetSupportingPlane();
 
+		/// don't use epsilon here to get exact split planes
 		const int cf = 
-			planePoly->ClassifyPlane(plane, 0.00001f);
+			planePoly->ClassifyPlane(plane, Limits::Small);
 			
 		// split new polygon with all previous planes
@@ -2499,5 +2551,8 @@
 					Polygon3 *backPoly = new Polygon3();
 
-					planePoly->Split(plane, *frontPoly, *backPoly);
+					planePoly->Split(plane, 
+									 *frontPoly, 
+									 *backPoly,
+									 epsilon);
 					
 					// don't need anymore
@@ -2506,5 +2561,5 @@
 
 					// back polygon is belonging to geometry
-					if (backPoly->Valid())
+					if (backPoly->Valid(epsilon))
 						planePoly = backPoly;
 					else
@@ -2525,29 +2580,2 @@
 	return planePoly;
 }
-
-void BspViewCellsStatistics::Print(ostream &app) const
-{
-	app << "===== BspViewCells statistics ===============\n";
-
-	app << setprecision(4);
-
-	//app << "#N_CTIME  ( Construction time [s] )\n" << Time() << " \n";
-
-	app << "#N_OVERALLPVS ( objects in PVS )\n" << pvs << endl;
-
-	app << "#N_PMAXPVS ( largest PVS )\n" << maxPvs << endl;
-
-	app << "#N_PMINPVS ( smallest PVS )\n" << minPvs << endl;
-
-	app << "#N_PAVGPVS ( average PVS )\n" << AvgPvs() << endl;
-
-	app << "#N_PEMPTYPVS ( view cells with PVS smaller 2 )\n" << emptyPvs << endl;
-
-	app << "#N_VIEWCELLS ( number of view cells)\n" << viewCells << endl;
-
-	app << "#N_AVGBSPLEAVES (average number of BSP leaves per view cell )\n" << AvgBspLeaves() << endl;
-
-	app << "#N_MAXBSPLEAVES ( maximal number of BSP leaves per view cell )\n" << maxBspLeaves << endl;
-	
-	app << "===== END OF BspViewCells statistics ==========\n";
-}
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.cpp	(revision 372)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Vector3.cpp	(revision 448)
@@ -2,7 +2,4 @@
 #include "Vector3.h"
 #include "Halton.h"
-
-float Vector3::sDistTolerance = 0.002f;
-float Vector3::sDistToleranceSqrt = 0.000004f;
 
 // Given min a vector to minimize and a candidate vector, replace
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp	(revision 445)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.cpp	(revision 448)
@@ -178,14 +178,18 @@
 		mViewCellsManager = new KdViewCellsManager(mKdTree);
 	}
-	if (strcmp(viewCellsStr, "bspTree") == 0)
+	else if (strcmp(viewCellsStr, "bspTree") == 0)
 	{
 		mBspTree = new BspTree();
+
+		Debug << "view cell type: Bsp" << endl;
 
 		environment->GetIntValue("BspTree.Construction.samples", constructionSamples);
 		mViewCellsManager = new BspViewCellsManager(mBspTree, constructionSamples);
 	}
-	if (strcmp(viewCellsStr, "vspBspTree") == 0)
+	else if (strcmp(viewCellsStr, "vspBspTree") == 0)
 	{
 		mVspBspTree = new VspBspTree();
+
+		Debug << "view cell type: VspBsp" << endl;
 
 		environment->GetIntValue("VspBspTree.Construction.samples", constructionSamples);
@@ -204,4 +208,5 @@
 		mBspTree = new BspTree();
 
+		Debug << "view cell type: Bsp" << endl;
 		environment->GetIntValue("BspTree.Construction.samples", constructionSamples);
 		mViewCellsManager = new BspViewCellsManager(mBspTree, constructionSamples);
Index: /trunk/VUT/GtpVisibilityPreprocessor/src/Plane3.h
===================================================================
--- /trunk/VUT/GtpVisibilityPreprocessor/src/Plane3.h	(revision 437)
+++ /trunk/VUT/GtpVisibilityPreprocessor/src/Plane3.h	(revision 448)
@@ -51,8 +51,7 @@
   */
   Vector3 FindIntersection(const Vector3 &a,
-			   const Vector3 &b,
-			   float *t = NULL,
-			   bool *coplanar = NULL
-			   ) const 
+						   const Vector3 &b,
+						   float *t = NULL,
+						   bool *coplanar = NULL) const 
   {
     const Vector3 v = b - a; // line from A to B
